package com.unipi.talepis.demo5681;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;

import android.app.AlarmManager;
import android.app.job.JobScheduler;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.provider.ContactsContract;
import android.util.Log;
import android.view.View;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.ImageRequest;
import com.android.volley.toolbox.JsonRequest;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;
import com.google.android.gms.tasks.OnSuccessListener;
import com.google.firebase.remoteconfig.FirebaseRemoteConfig;
import com.google.firebase.storage.FileDownloadTask;
import com.google.firebase.storage.FirebaseStorage;
import com.google.firebase.storage.StorageReference;

import java.io.File;
import java.io.IOException;

public class MainActivity extends AppCompatActivity {
    TextView textView1;
    static Handler mainHandler;
    MyLooperThread myLooperThread;
    EditText editText;
    FirebaseRemoteConfig remoteConfig;
    private StorageReference mStorageRef;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        textView1 = findViewById(R.id.textView1);
        editText = findViewById(R.id.editTextTextPersonName);
        mStorageRef = FirebaseStorage.getInstance().getReference();
        remoteConfig = FirebaseRemoteConfig.getInstance();
        new MyAsync().execute();
        AlarmManager alarmManager = (AlarmManager)getSystemService(ALARM_SERVICE);
        //create an intent
        //create a pendingIntent
        //alarmManager.set();
        //JobScheduler improves AlarmManager
        myLooperThread = new MyLooperThread();
        myLooperThread.start();
        mainHandler = new Handler(){
            @Override
            public void handleMessage(@NonNull Message msg) {
                textView1.setText(textView1.getText()+msg.getData().getString("mainMessage"));
            }
        };
    }
    private void loadImage(){
        StorageReference imageRef = mStorageRef.child("images/cat.png");
        try {
            File localFile = File.createTempFile("tmp","png");
            imageRef.getFile(localFile)
                    .addOnSuccessListener(new OnSuccessListener<FileDownloadTask.TaskSnapshot>() {
                        @Override
                        public void onSuccess(FileDownloadTask.TaskSnapshot taskSnapshot) {
                            //do something with the file
                            //ImageView imageView = findViewByID(......
                            //imageView.setImageBitmap(BitmapFactory.decodeFile(localFile.getAbsolutePath()));
                        }
                    });
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    public void go3(View view){
        RequestQueue requestQueue = Volley.newRequestQueue(this);
        //ImageRequest imageRequest για images
        //JsonRequest jsonRequest για json files
        String url = "http://www.unipi.com";
        StringRequest stringRequest = new StringRequest(Request.Method.GET, url,
                new Response.Listener<String>() {
                    @Override
                    public void onResponse(String response) {
                        textView1.setText(response);
                    }
                }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {
                textView1.setText(error.getMessage());
            }
        });
        requestQueue.add(stringRequest);
    }
    public void go2(View view){
        textView1.setText("");
        if (myLooperThread.isAlive()){
            Handler handler = myLooperThread.handler;
            Bundle bundle = new Bundle();
            String s = editText.getText().toString();
            bundle.putString("message",s);
            Message message = handler.obtainMessage();
            message.setData(bundle);
            handler.sendMessage(message);
        }else {
            Toast.makeText(this,"Thread is dead...",Toast.LENGTH_LONG).show();
        }
    }
    public void go1(View view){
        new Thread(new Runnable() {
            @Override
            public void run() {
                for (int i=0;i<=10;i++){
                    try {
                        Thread.sleep(1000);
                        int finalI = i;
                        runOnUiThread(()->{
                            textView1.setText(String.valueOf(finalI));
                        });
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                }
            }
        }).start();
    }

    class MyAsync extends AsyncTask<Integer,String,Double>{
        @Override
        protected void onPreExecute() {
            super.onPreExecute();
        }

        @Override
        protected void onPostExecute(Double aDouble) {
            super.onPostExecute(aDouble);
        }

        @Override
        protected void onProgressUpdate(String... values) {
            super.onProgressUpdate(values);
        }

        @Override
        protected Double doInBackground(Integer... integers) {
            return null;
        }
    }

}